@echo off
rem Usage: inst_eln version drive:dir
if "%2" == ""           goto Usage
if not "%3" == ""       goto Usage

set targ=%2
set ebin=none
if "%1" == "xtherc"     set ebin=elan1h
if "%1" == "xtega"      set ebin=elan1e
if "%1" == "xtcga"      set ebin=elan1c
if "%1" == "386herc"    set ebin=elan175
if "%1" == "386vga"     set ebin=elan175
if not "%ebin%" == "none" goto arg1ok
:Usage
echo Usage: inst_eln Version target-drive:dir
echo where Version is one of: xtherc xtega xtcga 386herc 386vga
echo Example: inst_eln 386vga c:\elan
echo see README for further details
goto end

:arg1ok
rem "len(targ) must be <= 37 (due to max linelength = 126)"
rem "s35: any string of length 35, to avoid long lines below"
set s35=12345678901234567890123456789012345
if %s35% == %s35%  set t38c=%targ%
if %s35% == %s35%   set t37c=%targ%
rem "               till here^ 19+2*35 =89 chars"
if %t37c% == %t38c% goto shortenough
echo inst_eln: target path too long (more than 37 characters), aborting
goto end

:shortenough
if "%ebin%" == "elan175" goto i386
:xt
rem test for dir  elanxt  with expected    bin       contents
set elnver=elanxt\bin\%ebin%.exe
if not exist %elnver% goto cantfind
set elnver=elanxt\bin\eln175p.bin
if not exist %elnver% goto cantfind
goto doinst

:i386
rem test for dir  elan386 with expected    bin,lib   contents
set elnver=elan386\bin\%ebin%.exe
if not exist %elnver% goto cantfind
set elnver=elan386\bin\%ebin%
if not exist %elnver% goto cantfind
set elnver=elan386\lib\elan175p.bin
if not exist %elnver% goto cantfind
set elnver=elan386\lib\emu387
if not exist %elnver% goto cantfind
if "%1" == "386vga"     goto doinst
set elnver=elan386\lib\herc.grd
if not exist %elnver% goto cantfind
goto doinst

:doinst
rem test existance of target dir by testing for NUL in that dir
if exist %targ%\nul           goto direxist
set newdir=%targ%
mkdir %newdir%
if not exist %newdir%\nul     goto cantcreat
echo inst_eln: created directory %newdir%

:direxist
set newdir=%targ%\bin
if exist %newdir%\nul goto already
set newdir=%targ%\lib
if exist %newdir%\nul goto already

set newdir=%targ%\bin
mkdir %newdir%
if not exist %newdir%\nul     goto cantcreat
echo inst_eln: created directory %newdir%
if "%ebin%" == "elan175" goto inst386

echo copying %ebin%.exe to elan.exe   (the Elan interpreter)
copy elanxt\bin\%ebin%.exe %newdir%\elan.exe
echo copying eln175p.bin              (start-up library)
copy elanxt\bin\eln175p.bin %newdir%
goto setpath

:inst386
set newdir=%targ%\lib
mkdir %newdir%
if not exist %newdir%\nul     goto cantcreat
echo inst_eln: created directory %newdir%
set newdir=%targ%\tmp
mkdir %newdir%
if not exist %newdir%\nul     goto cantcreat
echo inst_eln: created directory %newdir%

echo copying %ebin%.exe    (DOS extender)
copy elan386\bin\%ebin%.exe %targ%\bin
echo copying %ebin%        (the Elan interpreter)
copy elan386\bin\%ebin% %targ%\bin
echo copying elan175p.bin  (start-up library)
copy elan386\lib\elan175p.bin %targ%\lib
echo copying emu387        (FPU emulator)
copy elan386\lib\emu387 %targ%\lib
if "%1" == "386vga"     goto creatbat
echo copying herc.grd      (Hercules extension)
copy elan386\lib\herc.grd %targ%\lib

:creatbat
set batf=%targ%\BIN\ELAN.BAT
echo creating %batf%       (which starts it all up)

echo @echo off>> %batf%
rem next line limits target path to 37 chars (total linelength may be 126)
echo COMMAND /e:8192 /c %targ%\LIB\ELANGO>> %batf%
rem length:    24 + len(targ) + 11      + 3 + len(targ) + 13

set batf=%targ%\LIB\ELANGO.BAT
rem start creating the executive .BAT file
echo @echo off>> %batf%
echo cls>> %batf%
echo SET ELNDIR=%targ%>> %batf%
echo SET GO32TMP=%%ELNDIR%%\TMP>> %batf%
echo SET GO32=ansi emu %%ELNDIR%%\LIB\EMU387>> %batf%
if "%1" == "386vga"     goto nohercbat
echo SET GO32=%%GO32%% driver %%ELNDIR%%\LIB\HERC.GRD>> %batf%
:nohercbat
echo SET ELNPBIN=%%ELNDIR%%\LIB\ELAN175P.BIN>> %batf%
echo break=on>> %batf%
echo verify=on>> %batf%
echo %%ELNDIR%%\BIN\ELAN175>> %batf%

:setpath

echo;
echo Remember to put %targ%\BIN in your PATH (in AUTOEXEC.BAT).
goto end

:already
echo inst_eln: directory %newdir% already exists
echo Please install this version elsewhere or remove/rename
echo directories %targ%\BIN and %targ%\LIB
goto end
:cantfind
echo inst_eln: can't find %elnver% under current directory, aborting
goto end
:cantcreat
echo inst_eln: can't create directory %newdir%, aborting
goto end

:end
